var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  ShareFont: () => ShareFont,
  generateImage: () => generateImage
});
module.exports = __toCommonJS(src_exports);
var fs = __toESM(require("fs"));
var path = __toESM(require("path"));
var Canvas = __toESM(require("canvas"));
var { registerFont } = Canvas;
var ShareFont = class {
  constructor(id, name, path2) {
    let options = {
      id,
      name,
      path: path2,
      ShareFontOptions: {
        engine: "ShareImage.FontEngine",
        version: "v2.0.0"
      }
    };
    return options;
  }
};
var sirinStencil = new ShareFont("sirin-stencil", "Sirin Stencil", path.join(__dirname, "..", "..", "assets", "fonts", "sirin-stencil.ttf"));
var arial = new ShareFont("arial", "Arial", path.join(__dirname, "..", "..", "assets", "fonts", "arial.ttf"));
var defaultOptions = {
  tagline: "",
  titleFont: sirinStencil,
  taglineFont: arial,
  titleColor: "",
  imageWidth: 1280,
  imageHeight: 669,
  textLeftOffset: 480,
  titleBottomOffset: 254,
  textColor: "000000",
  titleFontSize: "64px",
  taglineFontSize: "48px"
};
function generateImage(src, title, output = { type: "base64" }, props = defaultOptions) {
  let _src = src;
  let _title = title;
  let _output = output;
  let {
    tagline = "",
    titleFont = sirinStencil,
    taglineFont = arial,
    titleColor = "",
    taglineColor,
    imageWidth = 1280,
    imageHeight = 669,
    textAreaWidth,
    textLeftOffset = 480,
    titleBottomOffset = 254,
    titleGravity,
    taglineGravity,
    textColor = "000000",
    titleFontSize = "64px",
    taglineFontSize = "48px"
  } = props;
  var _tagline = tagline, _titleFont = titleFont, _taglineFont = taglineFont, _titleColor = titleColor, _taglineColor = taglineColor, _imageWidth = imageWidth, _imageHeight = imageHeight, _textAreaWidth = textAreaWidth, _textLeftOffset = textLeftOffset, _titleBottomOffset = titleBottomOffset, _titleGravity = titleGravity, _taglineGravity = taglineGravity, _textColor = textColor, _titleFontSize = titleFontSize, _taglineFontSize = taglineFontSize;
  let img = new Canvas.Image();
  img.src = _src;
  return new Promise((resolve, reject) => {
    img.onload = () => {
      registerFont(_titleFont.path, { family: _titleFont.name });
      registerFont(_taglineFont.path, { family: _taglineFont.name });
      let canvas = Canvas.createCanvas(1280, 669);
      let ctx = canvas.getContext("2d");
      ctx.font = `${_titleFontSize} ${_titleFont.name}`;
      ctx.drawImage(img, 0, 0);
      ctx.fillText(_title, _textLeftOffset, _titleBottomOffset);
      ctx.font = `${_taglineFontSize} ${_taglineFont.name}`;
      ctx.fillText(_tagline, _textLeftOffset, 320);
      if (_output.type === "file") {
        let out = fs.createWriteStream(output.options.file.path);
        let stream = canvas.createPNGStream();
        stream.pipe(out);
        out.on("finish", () => {
          return;
        });
        return resolve(void 0);
      } else if (_output.type == "base64") {
        let buf = canvas.toBuffer("image/png");
        let b64 = buf.toString("base64");
        return resolve(b64);
      } else if (_output.type == "datauri") {
        let url = canvas.toDataURL();
        return resolve(url);
      } else if (_output.type == "buffer") {
        let buf = canvas.toBuffer("image/png");
        return resolve(buf);
      } else {
        let msg = { type: "ERROR", name: "UNSUPPORTED_TYPE", message: `The output type ${output.type} is not supported by ShareImage` };
        return resolve(msg);
      }
    };
  });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ShareFont,
  generateImage
});
